class FeedParser

  attr_reader :uri, :vendor_id, :site_id, :params, :headers

  def initialize(site_id, vendor_id)
    @vendor_id = vendor_id
    @site_id   = site_id
  end

  def create_coupons_from_xml(xml)
    doc = FeedMapper.massage_feed(xml)

    (doc.xpath("//item")).each do |item|
      advertiser_id = item.xpath("./advertiser-id/text()")
      item_id = item.xpath("./item-id/text()")

      unless(item_id.to_s.empty?)
        coupon = Coupon.find_or_create_by_advertiser_id_and_item_id(advertiser_id.to_s, item_id.to_s)
        coupon = CouponFactory.update_coupon_with_item(coupon,item, @site_id, @vendor_id)
        coupon.save
      end
    end
  end

=begin
  #START:  The things in this block don't belong here
  # This downloads the request.
  def download_feed()
    request = HtmlConnectionHelper.build_request(uri,params,headers)
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true if uri.port == 443
    response = http.request(request)

    return CGI.unescapeHTML(response.body)
  end

  # This takes a pre-massaged text, and creates coupons from it.
  def parse_feed(xml)
    doc = Nokogiri::XML(xml)
    total_num = doc.xpath("/root/total_num_pages/text()").to_s.to_i
    if(total_num > 1 && !massager.nil?)
      #need a way to solve for pagination universally
      (1..total_num/records_per_page).each do |n|
        page_number = {"page-number" => n}
        params.merge(page_number)
        feed = download_feed(uri, params, headers)
        feed = massager.massage_feed(feed)
        create_coupons_from_xml(feed)
      end
    else
      create_coupons_from_xml(xml)
    end
  
  end
  # END: The things in this block don't belong here.
=end
end
