namespace :coupon_feeds do
  desc "Populate Commission Junction Data"
  task :download_cj_data => :environment do
    website_id = Site.find_by_nice_name("amplified-media").id
    records_per_page = 100
    type_of_promotion = "coupon"
    params = {"website-id" => website_id,
      "advertiser-ids" => "joined",
      "records-per-page" => records_per_page,
      "promotion-type" => type_of_promotion,
      "page-number" => 1}
    ca = CouponAggregator.new(params, CouponAggregator::CJ)
    ca.aggregate(website_id)
  end

  desc "Populate For Me To Coupon Data"
  task :download_fmtc_data => :environment do
    ca = CouponAggregator.new({}, CouponAggregator::FMTC)
    ca.aggregate(nil)
  end
end

namespace :cj do
  desc "Work on Commission Junction's Feeds"
  task :get_advertisers => :environment do
    params = { 
      "advertiser-ids"=> "joined" 
    }
    cj_advertisers = CJAdvertisers.new(params)
    
    cj_advertisers.collect_advertisers
  end
end